###########################################################################
#
# win32 makefile -- common code between gsdl runtime and buildtime
# A component of the Greenstone digital library software
# from the New Zealand Digital Library Project at the
# University of Waikato, New Zealand.
#
# Copyright (C) 1999  The New Zealand Digital Library Project
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################

COMMONHOME = $(GSDLHOME)
COMMONHOME = $(MAKEDIR)
GSDL_VC4 = 0
DLL = 0
DLLDEBUG = 0
USE_SQLITE = 0

MDEFINES = /f win32.mak

INDEXERSDIR = indexers

COMPILEDIRS = packages\windows\gdbm\gdbm packages\windows\crypt\crypt \
	      packages\windows\expat\expat src\lib 

INSTALLDIRS = src\gdbmedit\db2txt src\gdbmedit\txt2db 

PACKAGEDIRS = 

SQLITE_DIR = packages\sqlite\sqlite-amalgamation-3.5.9

MAKECMD = $(MAKE) $(MDEFINES) GSDLHOME="$(GSDLHOME)"

!IF $(GSDL_VC4)
MAKECMD = $(MAKECMD) GSDL_VC4=1
!ENDIF
!IF $(DLL)
MAKECMD = $(MAKECMD) DLL=1
!ENDIF
!IF $(DLLDEBUG)
MAKECMD = $(MAKECMD) DLLDEBUG=1
!ENDIF
!IF $(USE_SQLITE)
MAKECMD = $(MAKECMD) USE_SQLITE=1
PACKAGEDIRS = $(PACKAGEDIRS) $(SQLITE_DIR)
!ENDIF

MAKECLEANCMD = $(MAKE) $(MDEFINES) clean

all: win32.mak $(INDEXERSDIR) $(PACKAGEDIRS) $(COMPILEDIRS) $(INSTALLDIRS) 

install: win32.mak $(INDEXERSDIR) $(INSTALLDIRS)

clean:
	cd packages\windows\crypt\crypt
	$(MAKECLEANCMD)
	cd "$(COMMONHOME)"
	cd packages\windows\gdbm\gdbm
	$(MAKECLEANCMD)
	cd "$(COMMONHOME)"
	cd packages\windows\expat\expat
	$(MAKECLEANCMD)
	cd "$(COMMONHOME)"
	cd src\lib
	$(MAKECLEANCMD)
	cd "$(COMMONHOME)"
	cd src\gdbmedit\txt2db
	$(MAKECLEANCMD)
	cd "$(COMMONHOME)"
	cd src\gdbmedit\db2txt
	$(MAKECLEANCMD)
	cd "$(COMMONHOME)"
	cd indexers
	call winMake.bat clean
	cd "$(COMMONHOME)"

$(COMPILEDIRS): FORCE
	cd "$@"
	$(MAKECMD)
	cd "$(GSDLHOME)"

$(INSTALLDIRS): FORCE
	cd "$@"
	$(MAKECMD)
	$(MAKECMD) install
	cd "$(COMMONHOME)"

$(SQLITE_DIR): FORCE
	cd "$@"
	$(MAKECMD)
	$(MAKECMD) install
	cd "$(COMMONHOME)"

$(INDEXERSDIR): FORCE
	cd "$@"
	call winMake.bat all gs2
	call winMake.bat install gs2
	if NOT EXIST "$(GSDLHOME)\bin\windows" mkdir "$(GSDLHOME)\bin\windows"
	if NOT EXIST "$(GSDLHOME)\bin\java" mkdir "$(GSDLHOME)\bin\java"
	for %%i in (bin\*.exe) do \
	  copy %%i "$(GSDLHOME)\bin\windows"
 	copy lucene-gs\LuceneWrapper.jar "$(GSDLHOME)\bin\java"
	cd "$(GSDLHOME)"

FORCE:

